<template>
<div id="coming-soon">
    <div class="container-fluid">
        <div class="row">
            <div class="col-md-12">
                <h1>I'm back, baby!</h1>
                <p>Soon we will be online with you.<br> In the meantime, you can contact our sales department through the chat in the bottom right corner.</p>
            </div>
        </div>

        <div class="chat-popup">
            <div class="chat-info">
                <p>Hi! How can we help you?</p>
                <div class="avatar-status">
                    <span class="user-status active">&nbsp;</span>
                    <img src="../../../assets/images/avatar-05.png" class="avatar-img">
                </div>
                <button class="button-close" style="display: none;"><img src="../../../assets/images/icon-close.svg"></button>
            </div>
            <div class="chat-inside-userdetails" v-if="chatOpened && !formFilled">
                <form>
                    <input placeholder="Vaše ime i prezime" v-model="nameLastName" />
                    <input placeholder="E-mail" v-model="email" />
                    <button class="btn-primary" @click.prevent="fillForm(nameLastName, email)">Start chat</button>
                </form>
            </div>
            <div class="chat-inside" v-if="chatOpened && formFilled">
                <div class="top">
                    <div v-for="(msg, msgIndex) of msgs" :key="msgIndex">
                        <ChatMsgWin :msg="msg" />
                    </div>                    
                </div>
            </div>
            <div class="bottom chat-input" v-if="buttonHidden">
                <form>
                    <input placeholder="Upišite svoju poruku..." v-model="text" />
                    <button class="button-send" @click.prevent="sendMessage(text)"><img src="../../../assets/images/icon-send.svg"></button>
                </form>
            </div>
            <button class="chat-now" @click="chatNow" v-if="!buttonHidden">Chat now</button>
        </div>
    </div>
</div>
</template>

<script>
import { useCookies } from 'vue3-cookies';
import ChatMsgWin from '@/components/ChatMsgWin.vue';

export default {
    name: 'ChatWin',
    setup()
    {
        const { cookies } = useCookies();
        return { cookies };
    },
    created()
    {
        this.init();
    },
    data()
    {
        return {
            chatOpened: false,
            formFilled: false,
            buttonHidden: false,
            text: '',
            nameLastName: '',
            email: '',
            sessionId: '',
            socketId: '',
            msgs: [],
        };
    },
    components: {
        ChatMsgWin,
    },
    sockets: {
        connect()
        {
            console.log('socket connected');
        },
        clientMessage(data)
        {
            const me = this;
            me.msgs.push(data.message);
        }
    },
    methods: {
        async init()
        {
            const me = this;
            me.sessionId = me.cookies.get('sessionId');
            if (me.sessionId == null)
            {
                me.cookies.set('sessionId', me.$uuid.v4());
                me.sessionId = me.cookies.get('sessionId');
            }
            else
            {
                const dataObject = await me.axios.get(`http://localhost:8000/history/${me.sessionId}`);
                if (dataObject.data.messages == null)
                {
                    me.msgs = [];
                }
                else
                {
                    me.msgs = dataObject.data.messages;
                }

                me.formFilled = true;
            }
        },
        fillForm(nameLastName, email)
        {
            const me = this;
            if (nameLastName !== '' && email !== '')
            {
                me.$socket.client.emit('newClient', {
                    sessionId: me.sessionId, nameLastName, email, // socketId: me.socketId,
                });
                me.formFilled = true;
            }
        },
        chatNow()
        {
            const me = this;
            me.chatOpened = true;
            me.buttonHidden = true;
        },
        sendMessage(text)
        {
            const me = this;
            if (text !== '')
            {
                const timestamp = Date.now();
                const message = {
                    admin: false,
                    msg: text,
                    timestamp,
                };

                me.$socket.client.emit('userResponse', {
                    sessionId: me.sessionId, socketId: me.socketId, lastUpdate: timestamp, message,
                });
                // showing message in chat pushing, no need for a new axios request
                me.msgs.push(message);
                // clears text field
                me.text = undefined;
            }
        },
    },
};
</script>
